var moment = require('moment');

exports.getToday = function(){
    var date = new Date();
    date.setHours(0, 0, 0, 0);
    return date;
};

exports.getTomorrow = function(){
    var date = new Date();
    date.setHours(0, 0, 0, 0);
    var tomorrow = new Date(date.getTime() + (24*60*60*1000));
    return tomorrow;
};

exports.getLastWeek = function(){
    var date = new Date();
    date.setHours(0, 0, 0, 0);
    var lastWeek = new Date(date.getTime() - (7*24*60*60*1000));
    return lastWeek;
};
exports.getNextHour = function(){
    var date = new Date();
    date.setHours(date.getHours()+1, date.getMinutes(), date.getSeconds(), date.getMilliseconds());
    return date;
};
exports.getCurrentHour = function(){
    var date = new Date();
    date.setHours(date.getHours(), 0, 0, 0);
    return date;
};

exports.getCurrentHourMinSec = function(){
    var date = new Date();
    date.setHours(date.getHours(), date.getMinutes(), date.getSeconds(), 0);
    return date;
};

exports.getLastSixHours = function(dateMax){
    var date = new Date(dateMax.date.getTime() - (6*60*60*1000));
    return date;
};

exports.getYesterdayCurrentHourMinSec = function(){
    var date = new Date();
    date.setHours(date.getHours(), date.getMinutes(), date.getSeconds(), 0);
    var yesterday = new Date(date.getTime() - (24*60*60*1000));
    return yesterday;
};

exports.getCurrentLastFifteenMinutes = function () {
    var date = new Date();
    date.setMinutes(date.getMinutes(), date.getSeconds(), date.getMilliseconds());
    return date;
};

exports.getNextFifteenMinutes = function () {
    var date = new Date();
    date.setMinutes(date.getMinutes()-15, date.getSeconds(), date.getMilliseconds());
    return date;
};

exports.getLastHour = function(){
    var date = new Date();
    date.setHours(date.getHours()-1, date.getMinutes(), date.getSeconds(), 0);
    return date;
};

exports.getlastDatesSince = function(lastDates){
    var lastDatesSince = new Date(lastDates);
    lastDatesSince.setMinutes(lastDatesSince.getMinutes()-1, 0, 0);
    return lastDatesSince;
};

exports.getlastDatesUntil = function(lastDates){
    var lastDatesUntil = new Date(lastDates);
    lastDatesUntil.setMinutes(lastDatesUntil.getMinutes()+1, 0, 0);
    return lastDatesUntil;
};
exports.formatDateLocale=function(fecha) {
    var dateString = fecha.toLocaleString();
    return dateString;
};

exports.getYesterdayStart=function (date) {
    var yesterdayStart = new Date(date);
    yesterdayStart.setHours(0, 0, 0, 0);
    var yesterday = new Date(yesterdayStart.getTime() - (24*60*60*1000));
    return yesterday;
};

exports.getYesterdayEnd=function (date) {
    var yesterdayEnd = new Date(date);
    yesterdayEnd.setHours(23, 59, 59, 0);
    var yesterday = new Date(yesterdayEnd.getTime() - (24*60*60*1000));
    return yesterday;

};

exports.getActualStart=function (date) {
    var yesterdayStart = new Date(date);
    yesterdayStart.setHours(0, 0, 0, 0);
    return yesterdayStart;
};

exports.getActualEnd=function (date) {
    var yesterdayEnd = new Date(date);
    yesterdayEnd.setHours(23, 59, 59, 0);
    return yesterdayEnd;

};
exports.getReporStyles=function () {

    var styles = {
        headerDark: {
            fill: {
                fgColor: {
                    rgb: 'FF000000'
                }
            },
            font: {
                color: {
                    rgb: 'FFFFFFFF'
                },
                sz: 14,
                bold: true,
                underline: true
            }
        },
        cellPink: {
            fill: {
                fgColor: {
                    rgb: 'FFFFCCFF'
                }
            }
        },
        cellGreen: {
            fill: {
                fgColor: {
                    rgb: 'FF00FF00'
                }
            }
        },
        celGray: {
            fill: {
                fgColor: {
                    rgb: 'E0E0E0'
                }
            }
        }
    };
return styles;
}

exports.reportsFormatDate =function(fecha) {
    return {
        dateString: ("0" + fecha.getUTCDate()).slice(-2) + "/" +
            ("0" + (fecha.getUTCMonth() + 1)).slice(-2) + "/" +
            fecha.getUTCFullYear() + " " +
            ("0" + fecha.getHours()).slice(-2) + ":" +
            ("0" + fecha.getUTCMinutes()).slice(-2) + ":" +
            ("0" + fecha.getUTCSeconds()).slice(-2)
    };
}


/**
 * Regular Expresion IndexOf for Arrays
 * This little addition to the Array prototype will iterate over array
 * and return the index of the first element which matches the provided
 * regular expresion.
 * Note: This will not match on objects.
 *
 * @param  {RegEx}   rx The regular expression to test with. E.g. /-ba/gim
 * @return {number} -1 means not found
 */
Array.prototype.regIndexOf = function (rx) {
    for (var i in this) {
        if (this[i].toString().match(rx)) {
            return i;
        }
    }
    return -1;
};

/**
 * Fuzzy Search in a Collection
 *
 * @param arrObj Array Object
 * @param search Regex that represents what is going to be searched
 * @return {Array} ArrayObject with an object of what we are looking for
 */
exports.search = function(arrObj, search) {

    var _ = require('underscore');

    var _return = [];
    /**
     * Runs deep the object, to his last nodes and returns an array with all the values.
     *
     * @param object Object that is going to be analized
     * @return {Array} with all the values of the object at the same level
     */
    var recursive = function(object) {
        return _.map(object, function (obj, key) {
            if (typeof obj !== 'object') {
                return obj.toString();
            } else {
                return recursive(obj);
            }
        });
    };
    // Search inside the flatten array which was returned by recursive
    _.each(recursive(arrObj), function (obj, key) {
        if (obj.regIndexOf(search) > -1) {
            _return.push(arrObj[key]);
        }
    }, this);
    return _return;
};


/**
 * Respuesta class.
 *
 * @constructor
 * @param {String} error
 * @param {String} tabla
 *  @param {String} accion
 */
exports.handleError= function (typeError , accion, res) {

    let codeStatus = 0;
    let message = ''
    switch (typeError) {
        case 'replicated':
            message = 'No se puede duplicar - ' + accion;
            codeStatus = 409;
            break;
        case 500:
            message = 'Error interno del servidor - ' + accion;
            codeStatus = 500;
            break;
        default:
            message = 'Ocurrio un error inesperado al - ' + accion;
            codeStatus = 409;
    }

    return res.status(codeStatus).send({error: message});
}

